<?php
function crop_upload_options_page() {
    if(function_exists('add_options_page')) {
        add_options_page(
            'Crop Image After Upload',
            'Crop Image Upload',
            'manage_options',
            'crop-after-upload',
            'crop_upload_render_options'
        );
    }
}

function crop_upload_get_options() {
    return [
        'enabled' => get_option('crop_upload_enabled') === 'yes',
        'width' => intval(get_option('crop_upload_width')),
        'height' => intval(get_option('crop_upload_height')),
        'quality' => intval(get_option('crop_upload_quality')),
        'position' => get_option('crop_upload_position', 'center')
    ];
}

function crop_upload_update_options($data) {
    if (!current_user_can('manage_options')) {
        return false;
    }

    $width = max(1, intval($data['width']));
    $height = max(1, intval($data['height']));
    $quality = max(1, min(100, intval($data['quality'])));
    $enabled = $data['enabled'] === 'yes' ? 'yes' : 'no';
    $position = in_array($data['position'], ['center', 'top', 'bottom']) ? $data['position'] : 'center';

    update_option('crop_upload_width', $width);
    update_option('crop_upload_height', $height);
    update_option('crop_upload_quality', $quality);
    update_option('crop_upload_enabled', $enabled);
    update_option('crop_upload_position', $position);

    return true;
}