<?php
/*
Plugin Name: Crop Image After Upload
Plugin URI: https://yassirkasmi.com/portfolio/crop-image-after-upload-plugin/
Description: This plugin automatically crops large image files when uploaded to the WordPress Media Library to a specified size.
Author: Yassir Kasmi
Version: 1.0.0
Author URI: https://yassirkasmi.com/
*/

require_once(__DIR__ . '/includes/options.php');
require_once(__DIR__ . '/includes/image-processor.php');
require_once(__DIR__ . '/includes/plugin-settings.php');

// Plugin version
define('CROP_UPLOAD_VERSION', '1.0.0');
define('CROP_UPLOAD_DEBUG', false);

// Initialize default options if not set
function crop_upload_init_options() {
    if(get_option('crop_upload_version') != CROP_UPLOAD_VERSION) {
        add_option('crop_upload_version', CROP_UPLOAD_VERSION, '', 'yes');
        add_option('crop_upload_width', '1200', '', 'yes');
        add_option('crop_upload_height', '1200', '', 'yes');
        add_option('crop_upload_quality', '90', '', 'yes');
        add_option('crop_upload_enabled', 'yes', '', 'yes');
        add_option('crop_upload_position', 'center', '', 'yes');
    }
}
register_activation_hook(__FILE__, 'crop_upload_init_options');

// Hook in the options page and upload handler
add_action('admin_menu', 'crop_upload_options_page');
add_action('wp_handle_upload', 'crop_upload_process_image');

// Add settings link to plugins page
add_filter('plugin_action_links_' . plugin_basename(__FILE__), 'crop_upload_plugin_links');

function crop_upload_plugin_links($links) {
    $settings_link = '<a href="options-general.php?page=crop-after-upload">Settings</a>';
    array_unshift($links, $settings_link);
    return $links;
}